'use strict';

var _expect = require('expect');

var _expect2 = _interopRequireDefault(_expect);

var _media = require('../media');

var _media2 = _interopRequireDefault(_media);

var _MediaQuery = require('../../models/MediaQuery');

var _MediaQuery2 = _interopRequireDefault(_MediaQuery);

var _RuleSet = require('../../models/RuleSet');

var _RuleSet2 = _interopRequireDefault(_RuleSet);

var _ValidRuleSetChild = require('../../models/ValidRuleSetChild');

var _ValidRuleSetChild2 = _interopRequireDefault(_ValidRuleSetChild);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('media', function () {
	it('should return a media query', function () {
		var result = (0, _media2.default)();
		(0, _expect2.default)(result).toBeA(_MediaQuery2.default);
	});

	it('should add the query', function () {
		var query = 'max-width: 200px';
		var result = (0, _media2.default)(query);
		(0, _expect2.default)(result.query).toEqual(query);
	});

	it('should have a RuleSet', function () {
		var rule = new _ValidRuleSetChild2.default();
		var result = (0, _media2.default)(undefined, rule);
		(0, _expect2.default)(result.ruleSet).toBeA(_RuleSet2.default);
	});

	it('should add a rule to the RuleSet', function () {
		var rule = new _ValidRuleSetChild2.default();
		var result = (0, _media2.default)(undefined, rule);
		(0, _expect2.default)(result.ruleSet.rules).toEqual([rule]);
	});

	it('should add multiple rules to the RuleSet', function () {
		var rule1 = new _ValidRuleSetChild2.default();
		var rule2 = new _ValidRuleSetChild2.default();
		var result = (0, _media2.default)(undefined, rule1, rule2);
		(0, _expect2.default)(result.ruleSet.rules).toEqual([rule1, rule2]);
	});
});