'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _concat = require('./concat');

var _concat2 = _interopRequireDefault(_concat);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

/*
* Toggle: Simple Namespaced styling
*
* example: flex = toggle('flex', {
*   default: rules.display('flex'), // always included
*   inline: rules.display('inline-flex'),
*   vertical: rules.flexDirection('column'),
* })
*
* flex() => `display: flex;`
* flex('inline vertical') => `display: flex; display: inline-flex; flex-direction: column;`
* */

exports.default = function (name, options) {
  return function () {
    var valueString = arguments.length <= 0 || arguments[0] === undefined ? '' : arguments[0];

    var _throw = function _throw(unknownValue) {
      var validValues = Object.keys(options).filter(function (v) {
        return v !== 'default';
      });
      throw new Error(name + ': Unknown value \'' + unknownValue + '\'. Valid values are:\n' + validValues.join('\n'));
    };

    var values = valueString.split(/ +/).filter(function (s) {
      return s.length > 0;
    });
    return _concat2.default.apply(undefined, [options.default].concat(_toConsumableArray(values.map(function (v) {
      return v in options ? options[v] : _throw(v);
    }))));
  };
};

module.exports = exports['default'];