'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _Root = require('./Root');

var _Root2 = _interopRequireDefault(_Root);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Element = function Element(tagName) {
  for (var _len = arguments.length, rules = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    rules[_key - 1] = arguments[_key];
  }

  var styleRoot = new (Function.prototype.bind.apply(_Root2.default, [null].concat(rules)))();
  /* Don't generate the styles now, only on render */
  var className = void 0;

  /* Return a stateless functional component that simply renders
  * a HTML element with our styles applied. */
  return function (props) {
    /* Need to be able to regenerate styles if things change, but for now everything's static */
    if (!className) className = styleRoot.injectStyles();
    return (0, _react.createElement)(tagName, Object.assign({}, props, {
      className: [props.className, className].join(' ')
    }));
  };
};

exports.default = Element;
module.exports = exports['default'];