'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _concat = require('../constructors/concat');

var _concat2 = _interopRequireDefault(_concat);

var _util = require('aphrodite/lib/util');

var _inject = require('aphrodite/lib/inject');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/*
 * The root node of a styling tree.
 * */
var Root = function () {
  function Root() {
    _classCallCheck(this, Root);

    this.ruleSet = _concat2.default.apply(undefined, arguments);
  }

  /* This is aphrodite-specifc but could be changed up */


  _createClass(Root, [{
    key: 'injectStyles',
    value: function injectStyles() {
      var _ruleSet$flatten = this.ruleSet.flatten();

      var rules = _ruleSet$flatten.rules;
      var fragments = _ruleSet$flatten.fragments;

      var className = '_' + (0, _util.hashObject)({ rules: rules, fragments: fragments });
      injectCss('.' + className, rules, fragments);
      return className;
    }
  }]);

  return Root;
}();

/* Recursive CSS injector */


exports.default = Root;
var injectCss = function injectCss(selector, rules, fragments) {
  (0, _inject.injectStyleOnce)(selector, selector, [rules], false);
  fragments.forEach(function (fragment) {
    injectCss(joinSelectors(selector, fragment.selector), fragment.rules, fragment.fragments);
  });
};

var joinSelectors = function joinSelectors(outer, inner) {
  return outer.split(/\s*,\s*/).map(function (outerPart) {
    return console.log('"' + outer + '" — "' + outerPart + '"') || (/&/.exec(inner) ? inner.replace(/&/g, outerPart) : outerPart + ' ' + inner).replace(/\s+$/, '');
  }).join(', ');
};
module.exports = exports['default'];